=== debian/changelog ===
toppic (1.7.10+cleaned1-2) unstable; urgency=low

  * Remove no more dependees from Depends for toppic-common.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 03 Nov 2025 16:54:16 +0100

toppic (1.7.10+cleaned1-1) unstable; urgency=low

  * New upstream version.

  * Repackaged source tree to actually remove unused code and other stuff,
    like .github...

  * Updated patches to use the Debian official packages for a number
    of libraries and install stuff at proper Debian-compatible locations.

  * Standards-Version: 4.7.2

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 20 Oct 2025 12:32:04 +0200

toppic (1.6.1+dfsg1-1) unstable; urgency=low

  * New upstream version.
  * Repackaged source tree to actually remove doc/wiki.
  * Standards-Version: 4.6.2

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 15 Jun 2023 16:24:14 +0200
