=== debian/control ===
Source: toppic
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               libhts-dev,
               libboost1.88-dev,
               libboost-filesystem1.88-dev,
               libboost-program-options1.88-dev,
               libboost-thread1.88-dev,
               libboost-system1.88-dev,
               libboost-iostreams1.88-dev,
               libboost-chrono1.88-dev,
               libeigen3-dev,
               libxerces-c-dev,
               qtbase5-dev,
               libpwizlite-dev,
               rapidjson-dev,
               librapidxml-dev,
               libprotobuf-dev,
               libonnx-dev,
               libonnxruntime-dev,
               zlib1g-dev,
# For rst2man
               python3-docutils
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debichem-team/toppic
Vcs-Git: https://salsa.debian.org/debichem-team/toppic.git
Homepage: http://proteomics.informatics.iupui.edu/software/toppic/index.html
Rules-Requires-Root: no

Package: toppic
Architecture: any
Depends: xalan,
         ${shlibs:Depends},
         ${misc:Depends},
         toppic-common (= ${source:Version})
Description: Top-down proteoform identification and characterization (programs)
 The TopPIC Suite consists of four software tools for the interpretation
 of top-down mass spectrometry data: TopFD, TopPIC, TopMG, and TopDiff.
 .
  -TopFD (Top-down mass spectral Feature Detection) is a software tool
    for top-down spectral deconvolution and a successor to MS-Deconv.  It
    groups top-down spectral peaks into isotopomer envelopes and converts
    isotopomer envelopes to monoisotopic neutral masses. In addition, it
    extracts proteoform features from LC-MS or CE-MS data.
 .
  -TopPIC (Top-down mass spectrometry based Proteoform Identification
    and Characterization) identifies and characterizes proteoforms at the
    proteome level by searching top-down tandem mass spectra against a
    protein sequence database. TopPIC is a successor to MS-Align+. It
    efficiently identifies proteoforms with unexpected alterations, such
    as mutations and post-translational modifications (PTMs), accurately
    estimates the statistical significance of identifications, and
    characterizes reported proteoforms with unknown mass shifts. It uses
    several techniques, such as indexes, spectral alignment, generation
    function methods, and the modification identification score (MIScore),
    to increase the speed, sensitivity, and accuracy.
 .
  -TopMG (Top-down mass spectrometry based proteoform identification
    using Mass Graphs) is a software tool for identifying ultra-modified
    proteoforms by searching top-down tandem mass spectra against a
    protein sequence database.  It is capable of identifying proteoforms
    with multiple variable PTMs and unexpected alterations, such as
    histone proteoforms and phosphorylated ones.  It uses mass graphs,
    which efficiently represent candidate proteoforms with multiple
    variable PTMs, to increase the speed and sensitivity in proteoform
    identification. In addition, approximate spectrum-based filtering
    methods are employed for protein sequence filtering, and a Markov
    chain Monte Carlo method (TopMCMC) is used for estimating the
    statistical significance of identifications.
 .
  -TopDiff (Top-down mass spectrometry-based identification of
    Differentially expressed proteoforms) compares the abundances of
    proteoforms and finds differentially expressed proteoforms by using
    identifications of top-down mass spectrometry data of several protein
    samples.

Package: toppic-common
Architecture: all
Depends: ${misc:Depends}
Description: Top-down proteoform identification and characterization (common data)
 The TopPIC Suite consists of four software tools for the interpretation
 of top-down mass spectrometry data: TopFD, TopPIC, TopMG, and TopDiff.
 .
  -TopFD (Top-down mass spectral Feature Detection) is a software tool
    for top-down spectral deconvolution and a successor to MS-Deconv.  It
    groups top-down spectral peaks into isotopomer envelopes and converts
    isotopomer envelopes to monoisotopic neutral masses. In addition, it
    extracts proteoform features from LC-MS or CE-MS data.
 .
  -TopPIC (Top-down mass spectrometry based Proteoform Identification
    and Characterization) identifies and characterizes proteoforms at the
    proteome level by searching top-down tandem mass spectra against a
    protein sequence database. TopPIC is a successor to MS-Align+. It
    efficiently identifies proteoforms with unexpected alterations, such
    as mutations and post-translational modifications (PTMs), accurately
    estimates the statistical significance of identifications, and
    characterizes reported proteoforms with unknown mass shifts. It uses
    several techniques, such as indexes, spectral alignment, generation
    function methods, and the modification identification score (MIScore),
    to increase the speed, sensitivity, and accuracy.
 .
  -TopMG (Top-down mass spectrometry based proteoform identification
    using Mass Graphs) is a software tool for identifying ultra-modified
    proteoforms by searching top-down tandem mass spectra against a
    protein sequence database.  It is capable of identifying proteoforms
    with multiple variable PTMs and unexpected alterations, such as
    histone proteoforms and phosphorylated ones.  It uses mass graphs,
    which efficiently represent candidate proteoforms with multiple
    variable PTMs, to increase the speed and sensitivity in proteoform
    identification. In addition, approximate spectrum-based filtering
    methods are employed for protein sequence filtering, and a Markov
    chain Monte Carlo method (TopMCMC) is used for estimating the
    statistical significance of identifications.
 .
  -TopDiff (Top-down mass spectrometry-based identification of
    Differentially expressed proteoforms) compares the abundances of
    proteoforms and finds differentially expressed proteoforms by using
    identifications of top-down mass spectrometry data of several protein
    samples.
 .
 This package ships common data used by the various program in the
 toppic package and some documentation.
