=== debian/changelog ===
toppic (1.8.0+repack1-1) unstable; urgency=low

  * New upstream release.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 13 Nov 2025 23:22:42 +0100
