=== debian/control ===
--- 
+++ 
@@ -4,28 +4,31 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               cmake,
-               pkgconf,
-               libhts-dev,
-               libboost1.88-dev,
-               libboost-filesystem1.88-dev,
-               libboost-program-options1.88-dev,
-               libboost-thread1.88-dev,
-               libboost-system1.88-dev,
-               libboost-iostreams1.88-dev,
-               libboost-chrono1.88-dev,
-               libeigen3-dev,
-               libxerces-c-dev,
-               qtbase5-dev,
-               libpwizlite-dev,
-               rapidjson-dev,
-               librapidxml-dev,
-               libprotobuf-dev,
-               libonnx-dev,
-               libonnxruntime-dev,
-               zlib1g-dev,
+ clang,
+ cmake,
+ pkgconf,
+ quilt,
+ libhts-dev,
+ libboost1.88-dev,
+ libboost-filesystem1.88-dev,
+ libboost-program-options1.88-dev,
+ libboost-thread1.88-dev,
+ libboost-system1.88-dev,
+ libboost-iostreams1.88-dev,
+ libboost-chrono1.88-dev,
+ libeigen3-dev,
+ libsqlite3-dev,
+ libxerces-c-dev,
+ qtbase5-dev,
+ libpwizlite-dev,
+ rapidjson-dev,
+ librapidxml-dev,
+ libprotobuf-dev,
+ libonnx-dev,
+ libonnxruntime-dev,
+ zlib1g-dev,
 # For rst2man
-               python3-docutils
+ python3-docutils
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debichem-team/toppic
 Vcs-Git: https://salsa.debian.org/debichem-team/toppic.git
